Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4647)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4648)
@@ -1,20 +1,19 @@
 !> @file init_grid.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -25,113 +24,110 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4630 2020-07-30 14:54:34Z suehring
 ! In case of ASCII topography input flag grid points as terrain and building.
 !
 ! 4601 2020-07-14 12:06:09Z suehring
 ! Minor formatting adjustments
-! 
+!
 ! 4564 2020-06-12 14:03:36Z raasch
 ! Vertical nesting method of Huq et al. (2019) removed
-! 
+!
 ! 4543 2020-05-20 14:12:22Z gronemeier
 ! Remove non-required check for canyon height
-! 
+!
 ! 4507 2020-04-22 18:21:45Z gronemeier
 ! update origin_z with shifting height of orography (oro_min)
-! 
+!
 ! 4457 2020-03-11 14:20:43Z raasch
 ! use statement for exchange horiz added,
 ! bugfix for call of exchange horiz 2d
-! 
+!
 ! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
-! 
+!
 ! 4414 2020-02-19 20:16:04Z suehring
 ! - Remove deprecated topography arrays nzb_s_inner, nzb_u_inner, etc.
-! - Move initialization of boundary conditions and multigrid into an extra
-!   module interface.
-! 
+! - Move initialization of boundary conditions and multigrid into an extra module interface.
+!
 ! 4386 2020-01-27 15:07:30Z Giersch
-! Allocation statements, comments, naming of variables revised and _wp added to 
-! real type values
-! 
+! Allocation statements, comments, naming of variables revised and _wp added to real type values
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Revise error messages for generic tunnel setup.
-! 
+!
 ! 4346 2019-12-18 11:55:56Z motisi
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
-! 
+! Introduction of wall_flags_total_0, which currently sets bits based on static topography
+! information used in wall_flags_static_0
+!
 ! 4340 2019-12-16 08:17:03Z Giersch
 ! Topography closed channel flow with symmetric boundaries implemented
-! 
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4328 2019-12-09 18:53:04Z suehring
 ! Minor change in nzb_max computation. Commentation added.
-! 
+!
 ! 4314 2019-11-29 10:29:20Z suehring
-! Set additional topography flag 4 to mark topography grid points emerged
-! from the filtering process.
-! 
+! Set additional topography flag 4 to mark topography grid points emerged from the filtering process.
+!
 ! 4294 2019-11-13 18:34:16Z suehring
-! Bugfix, always set bit 5 and 6 of wall_flags, indicating terrain- and 
-! building surfaces in all  cases, in order to enable terrain-following output 
-! also when no land- or urban-surface model is applied. 
-! 
+! Bugfix, always set bit 5 and 6 of wall_flags, indicating terrain- and building surfaces in all
+! cases, in order to enable terrain-following output also when no land- or urban-surface model is
+! applied.
+!
 ! 4265 2019-10-15 16:16:24Z suehring
-! Bugfix for last commit, exchange oro_max variable only when it is allocated 
-! (not necessarily the case when topography is input from ASCII file).
-! 
+! Bugfix for last commit, exchange oro_max variable only when it is allocated (not necessarily the
+! case when topography is input from ASCII file).
+!
 ! 4245 2019-09-30 08:40:37Z pavelkrc
 ! Store oro_max (building z-offset) in 2D for building surfaces
-! 
+!
 ! 4189 2019-08-26 16:19:38Z suehring
 ! - Add check for proper setting of namelist parameter topography
 ! - Set flag to indicate land surfaces in case no topography is provided
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
-! Pre-calculate topography top index and store it on an array (replaces former
-! functions get_topography_top_index)
-! 
+! Pre-calculate topography top index and store it on an array (replaces former functions
+! get_topography_top_index)
+!
 ! 4159 2019-08-15 13:31:35Z suehring
-! Revision of topography processing. This was not consistent between 2D and 3D
-! buildings. 
-! 
+! Revision of topography processing. This was not consistent between 2D and 3D buildings.
+!
 ! 4144 2019-08-06 09:11:47Z raasch
 ! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
-! 
+!
 ! 4115 2019-07-24 12:50:49Z suehring
-! Bugfix in setting near-surface flag 24, inidicating wall-bounded grid points 
-! 
+! Bugfix in setting near-surface flag 24, inidicating wall-bounded grid points
+!
 ! 4110 2019-07-22 17:05:21Z suehring
 ! - Separate initialization of advection flags for momentum and scalars.
 ! - Change subroutine interface for ws_init_flags_scalar to pass boundary flags
-! 
+!
 ! 4109 2019-07-22 17:00:34Z suehring
 ! Fix bad commit
-! 
+!
 ! 3926 2019-04-23 12:56:42Z suehring
-! Minor bugfix in building mapping when all building IDs in the model domain
-! are missing
-! 
+! Minor bugfix in building mapping when all building IDs in the model domain are missing
+!
 ! 3857 2019-04-03 13:00:16Z knoop
-! In projection of non-building 3D objects onto numerical grid remove 
-! dependency on building_type
-! 
+! In projection of non-building 3D objects onto numerical grid remove dependency on building_type
+!
 ! 3763 2019-02-25 17:33:49Z suehring
-! Replace work-around for ghost point exchange of 1-byte arrays with specific 
-! routine as already done in other routines
-! 
+! Replace work-around for ghost point exchange of 1-byte arrays with specific routine as already
+! done in other routines
+!
 ! 3761 2019-02-25 15:31:42Z raasch
 ! unused variables removed
-! 
+!
 ! 3661 2019-01-08 18:22:50Z suehring
-! Remove setting of nzb_max to nzt at non-cyclic boundary PEs, instead, 
-! order degradation of advection scheme is handeled directly in advec_ws
-! 
+! Remove setting of nzb_max to nzt at non-cyclic boundary PEs, instead, order degradation of
+! advection scheme is handeled directly in advec_ws
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! Comment added
@@ -142,50 +138,50 @@
 !
 ! Description:
-! -----------------------------------------------------------------------------!
+! -------------------------------------------------------------------------------------------------!
 !> Creating grid depending constants
 !> @todo: Rearrange topo flag list
-!> @todo: reference 3D buildings on top of orography is not tested and may need
-!>        further improvement for steep slopes
-!> @todo: Use more advanced setting of building type at filled holes 
-!------------------------------------------------------------------------------!
+!> @todo: reference 3D buildings on top of orography is not tested and may need further improvement
+!>        for steep slopes
+!> @todo: Use more advanced setting of building type at filled holes
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE init_grid
 
-    USE arrays_3d,                                                             &
+    USE arrays_3d,                                                                                 &
         ONLY:  dd2zu, ddzu, ddzu_pres, ddzw, dzu, dzw, x, xu, y, yv, zu, zw
 
-    USE control_parameters,                                                    &
-        ONLY:  constant_flux_layer, dz, dz_max, dz_stretch_factor,             &
-               dz_stretch_factor_array, dz_stretch_level, dz_stretch_level_end,&
-               dz_stretch_level_end_index, dz_stretch_level_start_index,       &
-               dz_stretch_level_start, ibc_uv_b, message_string,               &
-               number_stretch_level_end,                                       &
-               number_stretch_level_start,                                     &
-               ocean_mode,                                                     &
-               psolver,                                                        &
-               symmetry_flag,                                                  &
-               topography,                                                     &
+    USE control_parameters,                                                                        &
+        ONLY:  constant_flux_layer, dz, dz_max, dz_stretch_factor,                                 &
+               dz_stretch_factor_array, dz_stretch_level, dz_stretch_level_end,                    &
+               dz_stretch_level_end_index, dz_stretch_level_start_index,                           &
+               dz_stretch_level_start, ibc_uv_b, message_string,                                   &
+               number_stretch_level_end,                                                           &
+               number_stretch_level_start,                                                         &
+               ocean_mode,                                                                         &
+               psolver,                                                                            &
+               symmetry_flag,                                                                      &
+               topography,                                                                         &
                use_surface_fluxes
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  ddx, ddx2, ddy, ddy2, dx, dx2, dy, dy2, zu_s_inner, zw_w_inner
 
-    USE indices,                                                               &
-        ONLY:  nbgp,                                                           &
-               nx,                                                             &
-               nxl,                                                            &
-               nxlg,                                                           &
-               nxr,                                                            &
-               nxrg,                                                           &
-               ny,                                                             &
-               nyn,                                                            &
-               nyng,                                                           &
-               nys,                                                            &
-               nysg,                                                           &
-               nz,                                                             &
-               nzb,                                                            &
-               nzb_diff,                                                       &
-               nzb_max,                                                        &
-               nzt,                                                            &
-               topo_top_ind,                                                   &
+    USE indices,                                                                                   &
+        ONLY:  nbgp,                                                                               &
+               nx,                                                                                 &
+               nxl,                                                                                &
+               nxlg,                                                                               &
+               nxr,                                                                                &
+               nxrg,                                                                               &
+               ny,                                                                                 &
+               nyn,                                                                                &
+               nyng,                                                                               &
+               nys,                                                                                &
+               nysg,                                                                               &
+               nz,                                                                                 &
+               nzb,                                                                                &
+               nzb_diff,                                                                           &
+               nzb_max,                                                                            &
+               nzt,                                                                                &
+               topo_top_ind,                                                                       &
                topo_min_level
 
@@ -196,10 +192,10 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i             !< index variable along x 
+    INTEGER(iwp) ::  i             !< index variable along x
     INTEGER(iwp) ::  j             !< index variable along y
     INTEGER(iwp) ::  k             !< index variable along z
     INTEGER(iwp) ::  k_top         !< topography top index on local PE
     INTEGER(iwp) ::  n             !< loop variable for stretching
-    INTEGER(iwp) ::  number_dz     !< number of user-specified dz values       
+    INTEGER(iwp) ::  number_dz     !< number of user-specified dz values
     INTEGER(iwp) ::  nzb_local_max !< vertical grid index of maximum topography height
     INTEGER(iwp) ::  nzb_local_min !< vertical grid index of minimum topography height
@@ -209,6 +205,7 @@
     REAL(wp) ::  dz_level_end  !< distance between calculated height level for u/v-grid and user-specified end level for stretching
     REAL(wp) ::  dz_stretched  !< stretched vertical grid spacing
-    
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  min_dz_stretch_level_end !< Array that contains all minimum heights where the stretching can end
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  min_dz_stretch_level_end !< Array that contains all minimum heights where the stretching
+                                                                     !< can end
 
 
@@ -224,5 +221,5 @@
     ALLOCATE( x(0:nx) )
     ALLOCATE( xu(0:nx) )
-    
+
     DO i = 0, nx
        xu(i) = i * dx
@@ -232,5 +229,5 @@
     ALLOCATE( y(0:ny) )
     ALLOCATE( yv(0:ny) )
-    
+
     DO j = 0, ny
        yv(j) = j * dy
@@ -247,9 +244,9 @@
 
 !
-!-- For constructing an appropriate grid, the vertical grid spacing dz has to
-!-- be specified with a non-negative value in the parameter file
+!-- For constructing an appropriate grid, the vertical grid spacing dz has to be specified with a
+!-- non-negative value in the parameter file.
     IF ( dz(1) == -1.0_wp )  THEN
        message_string = 'missing dz'
-       CALL message( 'init_grid', 'PA0200', 1, 2, 0, 6, 0 ) 
+       CALL message( 'init_grid', 'PA0200', 1, 2, 0, 6, 0 )
     ELSEIF ( dz(1) <= 0.0_wp )  THEN
        WRITE( message_string, * ) 'dz=',dz(1),' <= 0.0'
@@ -258,59 +255,49 @@
 
 !
-!-- Initialize dz_stretch_level_start with the value of dz_stretch_level
-!-- if it was set by the user
+!-- Initialize dz_stretch_level_start with the value of dz_stretch_level if it was set by the user.
     IF ( dz_stretch_level /= -9999999.9_wp ) THEN
        dz_stretch_level_start(1) = dz_stretch_level
     ENDIF
-       
-!
-!-- Determine number of dz values and stretching levels specified by the
-!-- user to allow right controlling of the stretching mechanism and to
-!-- perform error checks. The additional requirement that dz /= dz_max
-!-- for counting number of user-specified dz values is necessary. Otherwise 
-!-- restarts would abort if the old stretching mechanism with dz_stretch_level
-!-- is used (Attention: The user is not allowed to specify a dz value equal
-!-- to the default of dz_max = 999.0). 
-    number_dz = COUNT( dz /= -1.0_wp .AND. dz /= dz_max)
-    number_stretch_level_start = COUNT( dz_stretch_level_start /=              &
-                                       -9999999.9_wp )
-    number_stretch_level_end = COUNT( dz_stretch_level_end /=                  &
-                                      9999999.9_wp )
-
-!
-!-- The number of specified end levels +1 has to be the same as the number 
+
+!
+!-- Determine number of dz values and stretching levels specified by the user to allow right
+!-- controlling of the stretching mechanism and to perform error checks. The additional requirement
+!-- that dz /= dz_max for counting number of user-specified dz values is necessary. Otherwise
+!-- restarts would abort if the old stretching mechanism with dz_stretch_level is used (Attention:
+!-- The user is not allowed to specify a dz value equal to the default of dz_max = 999.0).
+    number_dz = COUNT( dz /= -1.0_wp  .AND.  dz /= dz_max)
+    number_stretch_level_start = COUNT( dz_stretch_level_start /= -9999999.9_wp )
+    number_stretch_level_end = COUNT( dz_stretch_level_end /= 9999999.9_wp )
+
+!
+!-- The number of specified end levels +1 has to be the same as the number
 !-- of specified dz values
     IF ( number_dz /= number_stretch_level_end + 1 ) THEN
-       WRITE( message_string, * ) 'The number of values for dz = ',            &
-                                   number_dz, 'has to be the same as& ',       &
-                                   'the number of values for ',                &
-                                   'dz_stretch_level_end + 1 = ',              &
-                                   number_stretch_level_end+1
+       WRITE( message_string, * )  'The number of values for dz = ', number_dz,                    &
+                                   'has to be the same as& ', 'the number of values for ',         &
+                                   'dz_stretch_level_end + 1 = ', number_stretch_level_end+1
        CALL message( 'init_grid', 'PA0156', 1, 2, 0, 6, 0 )
     ENDIF
-    
-!
-!-- The number of specified start levels has to be the same or one less than 
-!-- the number of specified dz values
-    IF ( number_dz /= number_stretch_level_start + 1 .AND.                     &
-         number_dz /= number_stretch_level_start ) THEN
-       WRITE( message_string, * ) 'The number of values for dz = ',            &
-                                   number_dz, 'has to be the same as or one ', &
-                                   'more than& the number of values for ',     &
-                                   'dz_stretch_level_start = ',                &
-                                   number_stretch_level_start
+
+!
+!-- The number of specified start levels has to be the same or one less than the number of specified
+!-- dz values
+    IF ( number_dz /= number_stretch_level_start + 1  .AND.                                        &
+         number_dz /= number_stretch_level_start )  THEN
+       WRITE( message_string, * )  'The number of values for dz = ', number_dz,                    &
+                                   'has to be the same as or one ',                                &
+                                   'more than& the number of values for ',                         &
+                                   'dz_stretch_level_start = ', number_stretch_level_start
        CALL message( 'init_grid', 'PA0211', 1, 2, 0, 6, 0 )
     ENDIF
-    
-!-- The number of specified start levels has to be the same or one more than 
-!-- the number of specified end levels
-    IF ( number_stretch_level_start /= number_stretch_level_end + 1 .AND.      &
+
+!-- The number of specified start levels has to be the same or one more than the number of specified
+!-- end levels
+    IF ( number_stretch_level_start /= number_stretch_level_end + 1  .AND.                         &
          number_stretch_level_start /= number_stretch_level_end ) THEN
-       WRITE( message_string, * ) 'The number of values for ',                 &
-                                  'dz_stretch_level_start = ',                 &
-                                   dz_stretch_level_start, 'has to be the ',   &
-                                   'same or one more than& the number of ',    &
-                                   'values for dz_stretch_level_end = ',       &
-                                   number_stretch_level_end
+       WRITE( message_string, * )  'The number of values for ',                                    &
+                                   'dz_stretch_level_start = ', dz_stretch_level_start,            &
+                                   'has to be the ', 'same or one more than& the number of ',      &
+                                   'values for dz_stretch_level_end = ', number_stretch_level_end
        CALL message( 'init_grid', 'PA0216', 1, 2, 0, 6, 0 )
     ENDIF
@@ -318,18 +305,15 @@
 !
 !-- Initialize dz for the free atmosphere with the value of dz_max
-    IF ( dz(number_stretch_level_start+1) == -1.0_wp .AND.                     &
-         number_stretch_level_start /= 0 ) THEN 
+    IF ( dz(number_stretch_level_start+1) == -1.0_wp  .AND.  number_stretch_level_start /= 0 ) THEN
        dz(number_stretch_level_start+1) = dz_max
     ENDIF
-       
-!
-!-- Initialize the stretching factor if (infinitely) stretching in the free 
-!-- atmosphere is desired (dz_stretch_level_end was not specified for the 
-!-- free atmosphere)
-    IF ( number_stretch_level_start == number_stretch_level_end + 1 ) THEN 
-       dz_stretch_factor_array(number_stretch_level_start) =                   &
-       dz_stretch_factor
+
+!
+!-- Initialize the stretching factor if (infinitely) stretching in the free atmosphere is desired
+!-- (dz_stretch_level_end was not specified for the free atmosphere)
+    IF ( number_stretch_level_start == number_stretch_level_end + 1 )  THEN
+       dz_stretch_factor_array(number_stretch_level_start) = dz_stretch_factor
     ENDIF
-    
+
 !
 !-- Allocation of arrays for stretching
@@ -339,57 +323,50 @@
 !-- Define the vertical grid levels. Start with atmosphere branch
     IF ( .NOT. ocean_mode )  THEN
-    
-!
-!--    The stretching region has to be large enough to allow for a smooth
-!--    transition between two different grid spacings. The number 4 is an
-!--    empirical value
+
+!
+!--    The stretching region has to be large enough to allow for a smooth transition between two
+!--    different grid spacings. The number 4 is an empirical value.
        DO n = 1, number_stretch_level_start
-          min_dz_stretch_level_end(n) = dz_stretch_level_start(n) +            &
-                                        4 * MAX( dz(n),dz(n+1) )
+          min_dz_stretch_level_end(n) = dz_stretch_level_start(n) + 4 * MAX( dz(n),dz(n+1) )
        ENDDO
 
-       IF ( ANY( min_dz_stretch_level_end(1:number_stretch_level_start) >      &
-                 dz_stretch_level_end(1:number_stretch_level_start) ) ) THEN
-          message_string= 'Each dz_stretch_level_end has to be larger ' //     &
-                          'than its corresponding value for &' //              &
-                          'dz_stretch_level_start + 4*MAX(dz(n),dz(n+1)) '//   &
+       IF ( ANY( min_dz_stretch_level_end(1:number_stretch_level_start) >                          &
+                 dz_stretch_level_end(1:number_stretch_level_start) ) )  THEN
+          message_string= 'Each dz_stretch_level_end has to be larger ' //                         &
+                          'than its corresponding value for &' //                                  &
+                          'dz_stretch_level_start + 4*MAX(dz(n),dz(n+1)) '//                       &
                           'to allow for smooth grid stretching'
           CALL message( 'init_grid', 'PA0224', 1, 2, 0, 6, 0 )
        ENDIF
-       
-!
-!--    Stretching must not be applied within the surface layer 
-!--    (first two grid points). For the default case dz_stretch_level_start 
-!--    is negative. Therefore the absolut value is checked here.
+
+!
+!--    Stretching must not be applied within the surface layer (first two grid points). For the
+!--    default case dz_stretch_level_start is negative. Therefore the absolut value is checked here.
        IF ( ANY( ABS( dz_stretch_level_start ) <= dz(1) * 1.5_wp ) ) THEN
-          WRITE( message_string, * ) 'Each dz_stretch_level_start has to be ',&
-                                     'larger than ', dz(1) * 1.5
+          WRITE( message_string, * )  'Each dz_stretch_level_start has to be ',                    &
+                                      'larger than ', dz(1) * 1.5
           CALL message( 'init_grid', 'PA0226', 1, 2, 0, 6, 0 )
        ENDIF
 
 !
-!--    The stretching has to start and end on a grid level. Therefore 
-!--    user-specified values are mapped to the next lowest level. The  
-!--    calculation of the first level is realized differently just because of 
-!--    historical reasons (the advanced/new stretching mechanism was realized  
-!--    in a way that results don't change if the old parameters 
-!--    dz_stretch_level, dz_stretch_factor and dz_max are used)
-       IF ( number_stretch_level_start /= 0 ) THEN
-          dz_stretch_level_start(1) = INT( (dz_stretch_level_start(1) -        &
-                                            dz(1)/2.0) / dz(1) )               &
+!--    The stretching has to start and end on a grid level. Therefore user-specified values are
+!--    mapped to the next lowest level. The calculation of the first level is realized differently
+!--    just because of historical reasons (the advanced/new stretching mechanism was realized in a
+!--    way that results don't change if the old parameters dz_stretch_level, dz_stretch_factor and
+!--    dz_max are used).
+       IF ( number_stretch_level_start /= 0 )  THEN
+          dz_stretch_level_start(1) = INT( (dz_stretch_level_start(1) - dz(1)/2.0) / dz(1) )       &
                                       * dz(1) + dz(1)/2.0
        ENDIF
-       
+
        IF ( number_stretch_level_start > 1 ) THEN
           DO n = 2, number_stretch_level_start
-             dz_stretch_level_start(n) = INT( dz_stretch_level_start(n) /      &
-                                              dz(n) ) * dz(n)
-          ENDDO
-       ENDIF
-       
+             dz_stretch_level_start(n) = INT( dz_stretch_level_start(n) / dz(n) ) * dz(n)
+          ENDDO
+       ENDIF
+
        IF ( number_stretch_level_end /= 0 ) THEN
           DO n = 1, number_stretch_level_end
-             dz_stretch_level_end(n) = INT( dz_stretch_level_end(n) /          &
-                                            dz(n+1) ) * dz(n+1)
+             dz_stretch_level_end(n) = INT( dz_stretch_level_end(n) / dz(n+1) ) * dz(n+1)
           ENDDO
        ENDIF
@@ -397,5 +374,5 @@
 !
 !--    Determine stretching factor if necessary
-       IF ( number_stretch_level_end >= 1 ) THEN 
+       IF ( number_stretch_level_end >= 1 ) THEN
           CALL calculate_stretching_factor( number_stretch_level_end )
        ENDIF
@@ -403,21 +380,19 @@
 !
 !--    Grid for atmosphere with surface at z=0 (k=0, w-grid).
-!--    First compute the u- and v-levels. In case of dirichlet bc for u and v
-!--    the first u/v- and w-level (k=0) are defined at same height (z=0). 
-!--    The second u-level (k=1) corresponds to the top of the 
-!--    surface layer. In case of symmetric boundaries (closed channel flow), 
-!--    the first grid point is always at z=0.
-       IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2 .OR.                              & 
-            topography == 'closed_channel' ) THEN
+!--    First compute the u- and v-levels. In case of dirichlet bc for u and v the first u/v- and
+!--    w-level (k=0) are defined at same height (z=0).
+!--    The second u-level (k=1) corresponds to the top of the surface layer. In case of symmetric
+!--    boundaries (closed channel flow), the first grid point is always at z=0.
+       IF ( ibc_uv_b == 0  .OR.  ibc_uv_b == 2  .OR.  topography == 'closed_channel' )  THEN
           zu(0) = 0.0_wp
        ELSE
           zu(0) = - dz(1) * 0.5_wp
        ENDIF
-          
+
        zu(1) =   dz(1) * 0.5_wp
-       
-!
-!--    Determine u and v height levels considering the possibility of grid
-!--    stretching in several heights.
+
+!
+!--    Determine u and v height levels considering the possibility of grid stretching in several
+!--    heights.
        n = 1
        dz_stretch_level_start_index = nzt+1
